'use strict';

var objectURL;

var iframe = document.getElementById('frame');
var input = document.getElementById('url');

var screenshot = document.getElementById('screenshot');

window.addEventListener('click', function (e) {
  var target = e.target;

  function getScreenshot(iframe) {
    var promise = new Promise(function(resolve, reject) {
      // var request = iframe.getScreenshot(1256, 630);
      var request = iframe.getScreenshot(480, 270);

      request.onsuccess = function (e) {
        var blob = e.target.result;
        resolve(blob);
      };

      request.onerror = function () {
        console.log('getScreenshot failed');
      };
    });

    return promise;
  }

  function updateScreenshot(blob) {
    if (objectURL) {
      URL.revokeObjectURL(objectURL);
    }
    objectURL = URL.createObjectURL(blob);
    screenshot.style.backgroundImage = 'url(' + objectURL + ')';
  }

  switch (target.id) {
  case 'go-button':
    if (input.value.trim()) {
      iframe.src = input.value.trim();
    }
    break;
  case 'screenshot-button':
    getScreenshot(iframe).then(updateScreenshot);
    break;
  }
});
